# QData

**Data modifiers**: After reading data from any source such as Excel Smarty, Test Data Sheets, API, Database,  modifiers will be activated. Qatts has rich library of modifiers defined. On a dataset (QData) many modifiers can be configured to operate in sequential batches. Modifiers has to configured using product element properties.

Property name syntax: modifier.batc&#x68;**\[number]**.**\[Source Data Name].to.\[Result Data Name]**

**Source Data Name:** Source Data Name is the data key name on which data modification has to be done. if the data value is empty modifiers will not be executed.&#x20;

**Result Data Name:** Result Data Name is the data key name in which result of the modifier will be saved.

**Batch Number:** In some cases modifier has to be operated in a sequence. Use incremental numbers with prefix **batch**. All modifiers in a batch will be executed in any order.&#x20;

Property value syntax: **convertTo**:delimiter.\[Delimiter String/Char]

**Date Conversion:** Converting basic data to advanced data types

Expression to use: **convertTo**:delimiter.\[Delimiter String/Char]

Predefined Delimiters:  comma, dot, hash, hyphen

Custom Delimiter: must be defined in square brackets. Some examples:

**`delimiter.[and]`**` ``word and is delimiter`

**`delimiter.[break by]`**` ``word break by is delimiter`

**`delimiter.[']`**` ``character single quote is delimiter`

**Moving Data**: Moving data from one element to another element.

Expression to use:

**moveTo**:keyName.\[Child Column Name]:keyValue.\[Child Column Data]

Methods

String getKey()

boolean isEmpty()

boolean containsValue(Object object)

boolean hasDataFor(String dataName)

Integer size()

String\[] getKeyNames()

void setValue(String dataName,Object dataValue)

Object getValue(String dataName)

String getValueAsString(String dataName)

Integer getValueAsInteger(String dataName)

Double getValueAsDouble(String dataName)

Boolean getValueAsBoolean(String dataName)

QData getValueAsQData(String dataName)

String dump()

String toJson()

String toJsonArray(String keyName,String valueName)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.qatts.com/automation/objects/product-element/advanced-data-types/qdata.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
